import os
import sys

# from __future__ import print_function
import glob

from googleapiclient.discovery import build
from googleapiclient.errors import HttpError

SCRIPT_DIR = os.path.dirname(os.path.abspath(__file__))
sys.path.append(os.path.dirname(SCRIPT_DIR))

# The ID and range of a sample spreadsheet.
SAMPLE_SPREADSHEET_ID = '1-X2fyq26ZXO6XMOZdn8j8m3OQ9nfH7b0vdG4G7qkHrM'
KEY = 'AIzaSyBahzohvCmvdRG9ZZODLek9nY4v4Sszfg0'

def get_config_values(key, sheet_id, component_name):
    try:
        service = build(
            'sheets',
            'v4',
            developerKey=key)

        # Call the Sheets API
        sheet = service.spreadsheets()
        result = sheet.values().get(spreadsheetId=sheet_id, range=f"{component_name}!1:10002").execute()
        values = result.get('values', [])

        if not values:
            print('No data found.')
            return

        return values

    except HttpError as err:
        print(err)

    except Exception as err:
        print(err)

def get_components(key, sheet_id):
    try:
        service = build(
            'sheets',
            'v4',
            developerKey=key)


        result = list()

        sheet_metadata = service.spreadsheets().get(spreadsheetId=sheet_id).execute()
        properties = sheet_metadata.get('sheets')
        for item in properties:
            result.append(item["properties"]["title"])

        return result

    except HttpError as err:
        print(err)

    except Exception as err:
        print(err)

def process_services_configurator(key, sheet_id):
    import json 

    # Нужно забрать конфигурацию из гугл таблицы
    components = get_components(key, sheet_id)
    result_config = dict()
    for component in components:
        values = get_config_values(key, sheet_id, component)

        component_config = dict()

        if values is None:
            continue

        titles = values[0][1:]

        print(component)

        for row in values[1:]:

            terminal_config = dict()

            for cell_index, cell in enumerate(row[1:]):
                terminal_config[titles[cell_index]] = cell

            component_config[row[0]] = terminal_config

        result_config[component] = component_config

    # Нужно сгенерить json конфигурации для организации
    config_json = json.dumps(result_config, indent = 2)

    # Нужно добавить его в проект
    with open("./App/Resources/PluginsConfigs.json", "w",encoding='utf-8') as f:
        f.write(config_json)

if __name__ == "__main__":
    if os.environ['CI_PROJECT_NAME'] == "evosoft.services.configurator":
        key = os.environ['google_api_key']
        sheet_id = os.environ['google_api_sheet_id']
        process_services_configurator(key, sheet_id)
